#!/bin/bash

#===================================
SCRIPT_VERSION="Menu Script v.1.0.1"
SCRIPT_AUTHOR="HL5KY"
SCRIPT_DATE="09/08/2020"
#===================================

source /var/lib/dvswitch/dvs/var.txt

###################################################
# do_change_dmr_server
###################################################

function do_change_dmr_server() {
        clear
        TERM=ansi whiptail --title "$T029" --infobox "$T006" 8 60

        if [ $sel_ntwk = "Brandmeister" ]; then
                add=${bm_address}; port=${bm_port}; pswd=${bm_password}
        elif [ $sel_ntwk = "TGIF" ]; then
                add=${tgif_address}; port=${tgif_port}; pswd=${tgif_password}
        elif [ $sel_ntwk = "DMRPlus" ]; then
                add=${dmrplus_address}; port=${dmrplus_port}; pswd=${dmrplus_password}
        elif [ $sel_ntwk = $other1_name ]; then
                add=${other1_address}; port=${other1_port}; pswd=${other1_password}
        elif [ $sel_ntwk = $other2_name ]; then
                add=${other2_address}; port=${other2_port}; pswd=${other2_password}
        fi

        file=${MB}MMDVM_Bridge.ini
                update_ini ${file} "[DMR Network" Address ${add}
                update_ini ${file} "[DMR Network" Port ${port}
                update_ini ${file} "[DMR Network" Password ${pswd}
                sudo systemctl restart mmdvm_bridge

#sudo nano ${MB}MMDVM_Bridge.ini

clear

whiptail --msgbox "\
\
$sp16 $T003\n
" 8 50 1

if [ "$1" = "change" ]; then
${DVS}adnl_dmr.sh change; exit 0
elif [ "$1" = "edit" ]; then
${DVS}adnl_dmr.sh edit; exit 0
fi
}

###################################################
# do_bm
###################################################

do_bm() {

clear
if [ x${bm_address} = x ]; then

if (whiptail --title " $T405 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T408 = n/a
$sp05 $T409 = n/a
$sp05 $T410 = n/a
$sp05 --------------------------------
$sp05 $T416
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

else

if (whiptail --title " $T405 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T408 = ${bm_address}
$sp05 $T409 = ${bm_password}
$sp05 $T410 = ${bm_port}
$sp05 --------------------------------
$sp05 $T415
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

fi

#------- Create bm.list from DMR_Hotsts.txt ----------------------------------------------

sudo \cp -f ${DATA}bm.list ${DATA}bm.list_old > /dev/null 2>&1

# get the records starting "BM_" from DMR_Hosts.txt and create bm.list_1
sudo grep -i -e "^BM_" ${dir_host}DMR_Hosts.txt | sudo tee ${DATA}bm.list_1 > /dev/null 2>&1

# cut the first column from bm.list_1
sudo cut -f1 ${DATA}bm.list_1 | sudo tee ${DATA}bm.list_2 > /dev/null 2>&1

# add a new line "===Type_in===" in the last line of bm.list
#sudo bash -c 'echo ===Type_in=== >> /var/lib/dvswitch/dvs/bm.list' > /dev/null 2>&1

# number all the lines
sudo nl ${DATA}bm.list_2 | sudo tee ${DATA}bm.list > /dev/null 2>&1

# verify bm.list is valid
file=${DATA}bm.list
if [[ -z `sudo grep "BM_United_States_" $file` ]]; then
sudo \cp -f ${DATA}bm.list_old ${DATA}bm.list > /dev/null 2>&1
fi

sudo rm ${DATA}bm.list_* > /dev/null 2>&1

#------- Create bm.list from DMR_Hotsts.txt ----------------------------------------------

value=$(cat ${DATA}bm.list)
num=$(whiptail --title "Local Brandmeister Master Server" --menu "\
\n
      $T163
" 30 42 20 ${value} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

bm_name=$(sudo awk '$1 == '"$num"' { print $2 }' ${DATA}bm.list)

bm_master=
bm_address=$(awk '$1 == "'${bm_name}'" { print $3 }' ${dir_host}DMR_Hosts.txt)
bm_password=$(awk '$1 == "'${bm_name}'" { print $4 }' ${dir_host}DMR_Hosts.txt)
bm_port=$(awk '$1 == "'${bm_name}'" { print $5 }' ${dir_host}DMR_Hosts.txt)

bm_password=$(whiptail --title "$T009" --inputbox "$T162" 10 60 ${bm_password} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

for file in ${DATA}var.txt
do
        update_var bm_address ${bm_address}
        update_var bm_password ${bm_password}
        update_var bm_port ${bm_port}
done

if (whiptail --title " $T405 " --yesno "\
$sp05 Set this Network as a Default Server for DMR ?

$sp05 $T005
" 10 70); then
sel_ntwk=Brandmeister; clear
do_change_dmr_server edit
else clear; ${DVS}adnl_dmr.sh edit; exit 0
fi
}

###################################################
# do_dmrplus
###################################################

do_dmrplus() {

clear
if [ x${dmrplus_address} = x ]; then

if (whiptail --title " $T401 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T408 = n/a
$sp05 $T409 = n/a
$sp05 $T410 = n/a
$sp05 --------------------------------
$sp05 $T416
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

else

if (whiptail --title " $T401 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T408 = ${dmrplus_address}
$sp05 $T409 = ${dmrplus_password}
$sp05 $T410 = ${dmrplus_port}
$sp05 --------------------------------
$sp05 $T415
" 17 50); then :
else ${DVS}adnl_dmr.sh edit ; exit 0
fi

fi

#--- Create dmrplus.list from DMR_Hotsts.txt ----------------------------------------------

sudo \cp -f ${DATA}dmrplus.list ${DATA}dmrplus.list_old > /dev/null 2>&1

# get the records starting "DMR+_" from DMR_Hosts.txt and create dmrplus.list_1
sudo grep -i -e "^DMR+_" ${dir_host}DMR_Hosts.txt | sudo tee ${DATA}dmrplus.list_1 > /dev/null 2>&1

# cut the first column from dmrplus.list_1
sudo cut -f1 ${DATA}dmrplus.list_1 | sudo tee ${DATA}dmrplus.list_2 > /dev/null 2>&1

# add a new line "===Type_in===" in the last line of dmrplus.list
# sudo bash -c 'echo ===Type_in=== >> /var/lib/dvswitch/dvs/dmrplus.list' > /dev/null 2>&1

# number all the lines
sudo nl ${DATA}dmrplus.list_2 | sudo tee ${DATA}dmrplus.list > /dev/null 2>&1

# verify dmrplus.list is valid
file=${DATA}dmrplus.list
if [[ -z `sudo grep "DMR+_IPSC2-N" $file` ]]; then
sudo \cp -f ${DATA}bm.list_old ${DATA}bm.list > /dev/null 2>&1
fi

sudo rm ${DATA}dmrplus.list_* > /dev/null 2>&1

#--- Create dmrplus.list from DMR_Hotsts.txt ----------------------------------------------


value=$(sudo cat ${DATA}dmrplus.list)
        num=$(whiptail --title " $T401 " --menu "\
        \n
      $T280
        " 30 45 20 ${value} 3>&1 1>&2 2>&3)

if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

dmrplus_name=$(sudo awk '$1 == '"$num"' { print $2 }' ${DATA}dmrplus.list)

dmrplus_address=$(awk '$1 == "'${dmrplus_name}'" { print $3 }' ${dir_host}DMR_Hosts.txt)
dmrplus_password=$(awk '$1 == "'${dmrplus_name}'" { print $4 }' ${dir_host}DMR_Hosts.txt)
dmrplus_port=$(awk '$1 == "'${dmrplus_name}'" { print $5 }' ${dir_host}DMR_Hosts.txt)

for file in ${DATA}var.txt
do
        update_var dmrplus_address ${dmrplus_address}
        update_var dmrplus_password ${dmrplus_password}
        update_var dmrplus_port ${dmrplus_port}
done

if (whiptail --title " $T401 " --yesno "\
$sp05 Set this Network as a Default Server for DMR ?

$sp05 $T005
" 10 70); then
sel_ntwk=DMRPlus; clear
do_change_dmr_server edit
else clear; ${DVS}adnl_dmr.sh edit; exit 0
fi
}

###################################################
# do_tgif
###################################################

do_tgif() {

clear
if [ x${tgif_address} = x ]; then

if (whiptail --title " $T402 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T407 = n/a
$sp05 $T408 = n/a
$sp05 $T409 = n/a
$sp05 $T410 = n/a
$sp05 --------------------------------
$sp05 $T416
" 17 50); then :
else ${DVS}adnl_dmr.sh edit ; exit 0
fi

else

if (whiptail --title " $T402 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T408 = ${tgif_address}
$sp05 $T409 = ${tgif_password}
$sp05 $T410 = ${tgif_port}
$sp05 --------------------------------
$sp05 $T415
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

fi


tgif_address=$(whiptail --title "$T009" --inputbox "$T282" 10 60 ${tgif_address} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

tgif_password=$(whiptail --title "$T009" --inputbox "$T283" 10 60 ${tgif_password} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

tgif_port=$(whiptail --title "$T009" --inputbox "$T284" 10 60 ${tgif_port} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

for file in ${DATA}var.txt
do
        update_var tgif_address ${tgif_address}
        update_var tgif_password ${tgif_password}
	update_var tgif_port ${tgif_port}
done

if (whiptail --title " $T402 " --yesno "\
$sp05 Set this Network as a Default Server for DMR ?

$sp05 $T005
" 10 70); then
sel_ntwk=TGIF; clear
do_change_dmr_server edit
else clear; ${DVS}adnl_dmr.sh edit; exit 0
fi
}

###################################################
# do_other1
###################################################

do_other1() {

clear
if [ x${other1_address} = x ]; then

if (whiptail --title " $T403 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T407 = n/a
$sp05 $T408 = n/a
$sp05 $T409 = n/a
$sp05 $T410 = n/a
$sp05 --------------------------------
$sp05 $T416
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

else

if (whiptail --title " $T403 " --yesno "\

$sp05 $T406
$sp05 --------------------------------
$sp05 $T407 = ${other1_name}
$sp05 $T408 = ${other1_address}
$sp05 $T409 = ${other1_password}
$sp05 $T410 = ${other1_port}
$sp05 --------------------------------
$sp05 $T415
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

fi


other1_name=$(whiptail --title "$T009" --inputbox "$T286" 10 60 ${other1_name} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

other1_address=$(whiptail --title "$T009" --inputbox "$T287" 10 60 ${other1_address} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

other1_password=$(whiptail --title "$T009" --inputbox "$T288" 10 60 ${other1_password} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

other1_port=$(whiptail --title "$T009" --inputbox "$T289" 10 60 ${other1_port} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

for file in ${DATA}var.txt
do
        update_var other1_name ${other1_name}
        update_var other1_address ${other1_address}
        update_var other1_password ${other1_password}
        update_var other1_port ${other1_port}
done

clear

TERM=ansi whiptail --title "$T029" --infobox "$T006" 8 60

if [ -e ${AB}adv_dmr.txt ]; then
	file=${AB}adv_dmr.txt
	sudo sed -i -e "/^*other1/ c *other1,.    ${other1_name}" ${file}
fi

file=${adv}EN/adv_dmr.txt
sudo sed -i -e "/^*other1/ c *other1,.    ${other1_name}" ${file}

if [ -d ${adv}${LN} ]; then
	file=${adv}${LN}/adv_dmr.txt
	sudo sed -i -e "/^*other1/ c *other1,.    ${other1_name}" ${file}
fi

${DVS}88_restart.sh

if (whiptail --title " $T403 " --yesno "\
$sp05 Set this Network as a Default Server for DMR ?

$sp05 $T005
" 10 70); then
sel_ntwk=${other1_name}; clear
do_change_dmr_server edit
else clear; ${DVS}adnl_dmr.sh edit; exit 0
fi
}

###################################################
# do_other2
###################################################

do_other2() {

clear
if [ x${other2_address} = x ]; then

if (whiptail --title " $T403 " --yesno "\
$sp05 $T406
$sp05 --------------------------------
$sp05 $T407 = n/a
$sp05 $T408 = n/a
$sp05 $T409 = n/a
$sp05 $T410 = n/a
$sp05 --------------------------------
$sp05 $T416
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

else

if (whiptail --title " $T403 " --yesno "\
$sp05 $T406
$sp05 --------------------------------
$sp05 $T407 = ${other2_name}
$sp05 $T408 = ${other2_address}
$sp05 $T409 = ${other2_password}
$sp05 $T410 = ${other2_port}
$sp05 --------------------------------
$sp05 $T415
" 17 50); then :
else ${DVS}adnl_dmr.sh edit; exit 0
fi

fi


other2_name=$(whiptail --title "$T009" --inputbox "$T286" 10 60 ${other2_name} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

other2_address=$(whiptail --title "$T009" --inputbox "$T287" 10 60 ${other2_address} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

other2_password=$(whiptail --title "$T009" --inputbox "$T288" 10 60 ${other2_password} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

other2_port=$(whiptail --title "$T009" --inputbox "$T289" 10 60 ${other2_port} 3>&1 1>&2 2>&3)
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh edit; exit 0; fi

for file in ${DATA}var.txt
do
        update_var other2_name ${other2_name}
        update_var other2_address ${other2_address}
        update_var other2_password ${other2_password}
        update_var other2_port ${other2_port}
done

clear

TERM=ansi whiptail --title "$T029" --infobox "$T006" 8 60

if [ -e ${AB}adv_dmr.txt ]; then
	file=${AB}adv_dmr.txt
	sudo sed -i -e "/^*other2/ c *other2,.    ${other2_name}" ${file}
fi

file=${adv}EN/adv_dmr.txt
sudo sed -i -e "/^*other2/ c *other2,.    ${other2_name}" ${file}

if [ -d ${adv}${LN} ]; then
	file=${adv}${LN}/adv_dmr.txt
	sudo sed -i -e "/^*other2/ c *other2,.    ${other2_name}" ${file}
fi

${DVS}88_restart.sh

if (whiptail --title " $T404 " --yesno "\
$sp05 Set this Network as a Default Server for DMR ?

$sp05 $T005
" 10 70); then
sel_ntwk=${other2_name}; clear
do_change_dmr_server edit
else clear; ${DVS}adnl_dmr.sh edit; exit 0
fi
}

###################################################
# do_server_edit_menu
###################################################

function do_server_edit_menu() {

if [ "$other1_name" = '' ]; then other1_name=$T403; fi
if [ "$other2_name" = '' ]; then other2_name=$T404; fi

clear

sel=$(whiptail --title " $T400 " --menu "\
\n
$sp08 $T418

" 16 45 6 \
"1" "$T405" \
"2" "$T401" \
"3" "$T402" \
"4" "$other1_name" \
"5" "$other2_name" \
"6" "$T317" \
3>&1 1>&2 2>&3)

#exit 0
if [ $? != 0 ]; then ${DVS}adnl_dmr.sh; exit 0; fi

case $sel in
1)
do_bm ;;
2)
do_dmrplus ;;
3)
do_tgif ;;
4)
do_other1 ;;
5)
do_other2 ;;
6)
${DVS}adnl_dmr.sh; exit 0 ;;
esac
}

###################################################
# do_change_server_menu
###################################################

function do_change_server_menu() {
	clear
        networks="bm_address tgif_address dmrplus_address other1_address other2_address"
        name_list=(Brandmeister TGIF DMRPlus $other1_name $other2_name)

        for ntwk in ${networks}; do
                ntwk_val=${!ntwk}
                if [ x"${ntwk_val}" != x ]; then
                        no=$(($no+1))
                        ntwk_name=${name_list[$n]}
                        ntwk_name_with_no="$no $ntwk_name "
                        ntwk_name_list+="${ntwk_name_with_no} "
                fi
                n=$(($n+1))
        done

#---- Current Server -------
	file=${MB}MMDVM_Bridge.ini
	for ntwk in ${networks}; do
		ntwk_val=${!ntwk}
	        if [[ ! -z `sudo grep ${ntwk_val} $file` ]]; then
        	        curnt_ntwk=${name_list[$m]}; break
	        fi
        	m=$(($m+1))
	done
#-----------------------------

        hgt=$(($n+12))
        ntwk_name_list+="$n $T317 "

        sel=$(whiptail --title " $T400 " --menu "\n
$sp05 $T417

$sp05 $T419: $curnt_ntwk
        " $hgt 45 $n \
        $ntwk_name_list \
        3>&1 1>&2 2>&3)

        if [ $? != 0 ]; then ${DVS}adnl_dmr.sh; exit 0; fi

	if [ $sel = $n ]; then ${DVS}adnl_dmr.sh; exit 0; fi

        right_text="${ntwk_name_list#*$sel }"
        sel=$(($sel+1))
        sel_ntwk="${right_text%% $sel*}"
        #sel_ntwk=$(echo ${sel_ntwk} | tr -d ' ')

        echo $sel_ntwk
        do_change_dmr_server change
}

###################################################
# MAIN
###################################################

if [ "$1" = "change" ]; then
do_change_server_menu
elif [ "$1" = "edit" ]; then
do_server_edit_menu
fi

sel=$(whiptail --title " $T400 " --menu "\
\n
" 11 45 3 \
"1" "$T417" \
"2" "$T418" \
"3" "$T317" \
3>&1 1>&2 2>&3)

if [ $? != 0 ]; then ${DVS}adv_config_menu.sh; exit 0; fi

case $sel in
1)
do_change_server_menu ;;
2)
do_server_edit_menu ;;
3)
${DVS}adv_config_menu.sh; exit 0 ;;
esac

clear

exit 0
